<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>JavaScript Exercises Level1</title>
</head>

<body>

    <script>
        // Exercise 13
        function extractPersonBirthYear(code) {
            let initialDigit = +code.substr(0, 1);
            let birthYearDigits = +code.substr(1, 2);
            let birthYear = birthYearDigits;

            switch (initialDigit) {
                case 1:
                case 2:
                    birthYear += 1800;
                    break;
                case 3:
                case 4:
                    birthYear += 1900;
                    break;
                case 5:
                case 6:
                    birthYear += 2000;
                    break;
                case 7:
                case 8:
                    birthYear += 2100;
                    break;
            }

            return birthYear;
        }

        console.log("The person was born in ", extractPersonBirthYear("49403136515"));

        // Exercise 14
        const extractPersonGender = code => +code.substr(0, 1) % 2 == 1 ? 'M' : 'N';

        function extractPersonGender2(code) {
            let initialDigit = parseInt(code.slice(0, 1));
            if (initialDigit % 2 == 1) {
                return 'M';
            } else {
                return 'N';
            }
        }

        console.log("The person gender is ", extractPersonGender("49403136515"));

        // Exercise 15
        function isPersonalCodeValid(code) {
            const weights1 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 1];
            let sum = 0;
            for(let i = 0; i < weights1.length; i++) {
                sum = sum + weights1[i] * +code.substr(i, 1);
            }
            let calculatedCheckNumber = sum % 11;
            if (calculatedCheckNumber !== 10) {
                return +code.substr(10, 1) === calculatedCheckNumber;
            } else {
                const weights2 = [3, 4, 5, 6, 7, 8, 9, 1, 2, 3];
                sum = 0;
                for(let j = 0; j < weights2.length; j++) {
                    sum += weights2[j] * +code.substr(j, 1);
                }
                calculatedCheckNumber = sum % 11;
                if (calculatedCheckNumber === 10) {
                    return 0 === +code.substr(10, 1);
                } else {
                    return calculatedCheckNumber === +code.substr(10, 1);
                }
            }
        }

        console.log("Is personal code correct?", isPersonalCodeValid("49403136515"));
    </script>
</body>

</html>